# Fields

{% hint style="success" %}
This is the official documentation of the `forestadmin-agent-django` and `forestadmin-agent-flask` Python agents.
{% endhint %}

Forest Admin is a platform to administrate your business operations efficiently; it provides powerful features to ease data navigation and implement high level views.

When designing databases and APIs, the way to go is usually to push for normalization. This means ensuring there is no redundancy of data (all data is stored in only one place), and that data dependencies are logical.

On the other hand, graphical user interfaces usually need duplication and shortcuts to be user-friendly.

To bridge that gap, Forest Admin allows adding, moving, removing, and overriding behaviors from fields.

### Minimal example

```python
from forestadmin.datasource_toolkit.context.collection_context import CollectionCustomizationContext

agent.customize_collection("User").add_field(
    "fullName",
    {
        "column_type": "String",
        "dependencies": ["firstName", "lastName"],
        "get_values": "get_user_full_name",
    }
    # Make it writable
).replace_field_writing(
    "fullname",
    lambda value, context: {
        "firstName": value.split(" ")[0], "lastName": value.split(" ")[1]
    }
    # add validations
).add_field_validation(
    "fullName", "present"
).add_field_validation(
    "fullName", "shorter_than", 30
).add_field_validation(
    "fullName", "longer_than", 2
    # Make it filterable and sortable
).emulate_field_filtering(
    "fullName"
).emulate_field_sorting(
    "fullName"
    # remove  previous fields
).remove_field(
    "firstName", "lastName"
)

```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-python/agent-customization/fields.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
